﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

public partial class Product : System.Web.UI.Page
{
    public static DataTable cart;

    //ページ読込時の処理
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            //カート変数の初期化
            cart = new DataTable();
            DataColumn dc1 = new DataColumn("ProductNo", System.Type.GetType("System.Int32"));
            DataColumn dc2 = new DataColumn("ProductName", System.Type.GetType("System.String"));
            DataColumn dc3 = new DataColumn("UnitPrice", System.Type.GetType("System.Int32"));
            DataColumn dc4 = new DataColumn("OrderQuantity", System.Type.GetType("System.Int32"));
            DataColumn dc5 = new DataColumn("Price", System.Type.GetType("System.Int32"));
            cart.Columns.Add(dc1);
            cart.Columns.Add(dc2);
            cart.Columns.Add(dc3);
            cart.Columns.Add(dc4);
            cart.Columns.Add(dc5);
        }
    }

    //「注文する」ボタンの処理
    protected void btnOrder_Click(object sender, EventArgs e)
    {
        if (cart.Rows.Count > 0)
        {
            Session["Cart"] = cart;
            Response.Redirect("Login.aspx");
        }
        else
        {
            //カートにひとつも商品がない場合は画面にエラーを表示する
            Response.Write("<center><font color=\"red\">商品を選択してください。</font></center>");
        }
    }

    //「カートに入れる」ボタンの処理
    protected void grdShohin_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName == "Select")
        {
            int index = Int32.Parse((String)e.CommandArgument);

            //在庫があるか？
            int StockQuantity = Int32.Parse(grdProduct.Rows[index].Cells[4].Text);
            if (StockQuantity > 0)
            {
                DataRow[] dr = cart.Select("ProductNo = '" + grdProduct.Rows[index].Cells[0].Text + "'");

                //既にカートに同じ商品があるか？
                if (dr.Length > 0)
                {
                    //数量を+1する
                    DataRow item = dr[0];
                    item["OrderQuantity"] = Int32.Parse(item["OrderQuantity"].ToString()) + 1;
                    item["Price"] = Int32.Parse(item["UnitPrice"].ToString()) * Int32.Parse(item["OrderQuantity"].ToString());
                }
                else
                {
                    //ない場合は新たにレコードを作成する
                    DataRow item = cart.NewRow();
                    item["ProductNo"] = grdProduct.Rows[index].Cells[0].Text;
                    item["ProductName"] = grdProduct.Rows[index].Cells[1].Text;
                    item["UnitPrice"] = grdProduct.Rows[index].Cells[3].Text;
                    item["OrderQuantity"] = 1;
                    item["Price"] = item["UnitPrice"];
                    cart.Rows.Add(item);
                }

                //在庫の表示を-１する
                grdProduct.Rows[index].Cells[4].Text = (StockQuantity - 1).ToString();

                //カート情報を更新する
                int quantity = 0;
                int total = 0;
                foreach (DataRow item in cart.Rows)
                {
                    quantity += Int32.Parse(item["OrderQuantity"].ToString()); //購入数量
                    total += Int32.Parse(item["Price"].ToString());           //合計金額(送料除く)
                }
                lblOrderQuantity.Text = quantity.ToString();
                lblPrice.Text = total.ToString();
            }
            else
            {
                //在庫がない場合は画面にエラーを表示する
                Response.Write("<center><font color=\"red\">在庫がありません！</font></center>");
            }
        }
    }

    protected void btnFind_Click(object sender, EventArgs e)
    {

    }
    protected void txtProductName_TextChanged(object sender, EventArgs e)
    {

    }
}
